//----------------------------------------------------------------------------

//Encoder support module: header file

//----------------------------------------------------------------------------

#ifndef ENCODER_HPP
#define ENCODER_HPP

//----------------------------------------------------------------------------

#include "keyboard.hpp"

//----------------------------------------------------------------------------
//---------------------------- TEncoder class: -------------------------------
//----------------------------------------------------------------------------

class TEncoder
{
private:
  enum EncoderState
  {
    STATE_0,
    STATE_A,
    STATE_B,
    STATE_AB
  };
  Pin_EF2_t Pin_EF2;
  Pin_EF1_t Pin_EF1;
  uint8_t EncType;
  uint8_t EncPrev;
  uint8_t EncPrevPrev;
public:
  TEncoder(void);
  void Execute(void);
  void SetType(uint8_t t);
  KeyMsg_t Message;
};

//----------------------------------------------------------------------------

extern TEncoder *Encoder;

//----------------------------------------------------------------------------

#endif

